/*
 *	main.c
 *
 *	dwav2gsm - WAV to GSM Ro[^
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Mon Jun 19 19:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Jun 20 12:30:00 JST 2002 Naoyuki Sawa
 *	- usage()CAo[W\ǉB
 *	* Mon Jun 21 04:39:00 JST 2002 Naoyuki Sawa
 *	- "-b"IvV(ԃt@Cc)ǉB
 */
#define STRICT
#include <windows.h>
#include <mmreg.h>
#include <msacm.h>
#include <stdio.h>
#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "msacm32.lib")
/* R}hCWJ邽߂ɁA
 * vWFNg̐ݒŁAsetargv.objNĂ
 */
#include "gsm/gsm.h"

#define VERSION			"20020621"
#define DEFAULT_RATE		8000		/* GSMW̕ϊ[g      */
#define IN_BUFFER_SIZE		65536		/* oCgÂϊ邩H */

int rate = DEFAULT_RATE;	/* ϊ[g         */
int keep = 0;			/* ԃt@Cc */

void wav2pcm(const char* in_path, const char* out_path);
void pcm2gsm(const char* in_path, const char* out_path);

void
usage()
{
	fprintf(stderr, "dwav2gsm - WAV to GSM Ro[^ (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2002 Naoyuki Sawa <nsawa@north.hokkai.net>\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE  F wav2gsm [options] [filename[.wav] [filename[.wav] [...]]]\n");
	fprintf(stderr, "OPTIONSF -r<rate> ... ϊ[gw肵܂B(wȂ=%d[Hz])\n", DEFAULT_RATE);
	fprintf(stderr, "          -b       ... ԃt@C(.pcm)c܂B\n");
	exit(1);
}

int
main(int argc, char* argv[])
{
	int i;
	char* p;
	char wav_path[_MAX_PATH];
	char wav_drive[_MAX_PATH];
	char wav_dir[_MAX_PATH];
	char wav_fname[_MAX_PATH];
	char wav_ext[_MAX_PATH];
	char pcm_path[_MAX_PATH];
	char gsm_path[_MAX_PATH];

	if(argc == 1) usage();
	i = 1;

	/* R}hCIvV͂܂B */
	while(i < argc) {
		p = argv[i];
		if(p[0] != '-') break;
		switch(p[1]) {
		case 'r': /* ϊ[g */
			rate = atoi(&p[2]);
			if(rate == 0) usage();
			break;
		case 'b': /* ԃt@CcB'b'̗RFpcc33ɍ킹 */
			keep = 1;
			break;
		}
		i++;
	}

	/* Ɏw肳ꂽSt@C܂B */
	while(i < argc) {
		p = argv[i];
		strcpy(wav_path, p);
		_splitpath(wav_path, wav_drive, wav_dir, wav_fname, wav_ext);
		if(wav_ext[0] == '\0') {
			strcpy(wav_ext, ".wav");
			_makepath(wav_path, wav_drive, wav_dir, wav_fname, wav_ext);
		}
		_makepath(pcm_path, wav_drive, wav_dir, wav_fname, ".pcm");
		_makepath(gsm_path, wav_drive, wav_dir, wav_fname, ".gsm");
		fprintf(stderr, "%s\n", wav_path);
		wav2pcm(wav_path, pcm_path);
		pcm2gsm(pcm_path, gsm_path);
		if(!keep) remove(pcm_path);
		i++;
	}

	return 0;
}

void
wav2pcm(const char* wav_path, const char* pcm_path)
{
	int retval, remain;
	HMMIO wav_mmio;
	MMCKINFO ck_riff;
	MMCKINFO ck_fmt;
	MMCKINFO ck_data;
	WAVEFORMATEX* wav_fmt;
	FILE* pcm_file;
	WAVEFORMATEX pcm_fmt;
	HACMSTREAM acm;
	ACMSTREAMHEADER stream;
	int wav_unit;
	int pcm_unit;

	/* WAVt@CJ܂B */
	wav_mmio = mmioOpen((char*)wav_path, NULL, MMIO_READ);
	if(wav_mmio == NULL) {
		fprintf(stderr, "### WAVt@CJ܂B\n");
		abort();
	}

	/* PCMt@CJ܂B */
	pcm_file = fopen(pcm_path, "wb");
	if(pcm_file == NULL) {
		fprintf(stderr, "### PCMt@C쐬ł܂B\n");
		abort();
	}

	/* RIFF:WAVE`Nɓ܂B */
	memset(&ck_riff, 0, sizeof(MMCKINFO));
	ck_riff.ckid    = mmioStringToFOURCC("RIFF", 0); /* MMIO_FINDRIFF́Ackif̎w͏ȗ\ */
	ck_riff.fccType = mmioStringToFOURCC("WAVE", 0);
	retval = mmioDescend(wav_mmio, &ck_riff, NULL, MMIO_FINDRIFF);
	if(retval != 0) {
		fprintf(stderr, "### RIFF`N܂B\n");
		abort();
	}

	/* fmt`Nɓ܂B */
	memset(&ck_fmt, 0, sizeof(MMCKINFO));
	ck_fmt.ckid = mmioStringToFOURCC("fmt", 0);
	retval = mmioDescend(wav_mmio, &ck_fmt, &ck_riff, MMIO_FINDCHUNK);
	if(retval != 0) {
		fprintf(stderr, "### fmt`N܂B\n");
		abort();
	}

	/* WAVwb_ǂݍ݂܂B */
	wav_fmt = (WAVEFORMATEX*)malloc(ck_fmt.cksize);
	if(wav_fmt == NULL) {
		fprintf(stderr, "### słB\n");
		abort();
	}
	retval = mmioRead(wav_mmio, (char*)wav_fmt, ck_fmt.cksize);
	if(retval != (int)ck_fmt.cksize) {
		fprintf(stderr, "### WAVt@CsłB\n");
		abort();
	}

	/* fmt`N𔲂܂B */
	retval = mmioAscend(wav_mmio, &ck_fmt, 0);
	if(retval != 0) {
		fprintf(stderr, "### WAVt@CsłB\n");
		abort();
	}

	/* data`Nɓ܂B */
	memset(&ck_data, 0, sizeof(MMCKINFO));
	ck_data.ckid = mmioStringToFOURCC("data", 0);
	retval = mmioDescend(wav_mmio, &ck_data, &ck_riff, MMIO_FINDCHUNK);
	if(retval != 0) {
		fprintf(stderr, "### data`N܂B\n");
		abort();
	}

	/* ACMXg[J܂B
	 * WAVt@CjAPCMȊǑ`(ႦADPCMƂ)ƁAs܂B
	 *   ʌ`EʃTvO[gւ̕ΐAxł͍s܂B
	 *   ϊsƂőΉ\łÂ݂Ƃ͖ΉƂ܂B
	 */
	memset(&pcm_fmt, 0, sizeof pcm_fmt);
	pcm_fmt.wFormatTag = WAVE_FORMAT_PCM;	/* jAPCM           */
	pcm_fmt.nChannels = 1;			/* m            */
	pcm_fmt.nSamplesPerSec = rate;		/* 8KHz                */
	pcm_fmt.nAvgBytesPerSec = rate * 2 * 1;	/* 8KHz,16bit,m */
	pcm_fmt.nBlockAlign = 2 * 1;		/* 16bit,m      */
	pcm_fmt.wBitsPerSample = 16;		/* 16bit               */
	retval = acmStreamOpen(&acm, NULL, wav_fmt, &pcm_fmt, NULL, 0, 0, ACM_STREAMOPENF_NONREALTIME);
	if(retval != 0) {
		fprintf(stderr, "### ACMXg[J܂B\n");
		fprintf(stderr, "### ԂWAVt@CjAPCMȊǑ`łB\n");
		fprintf(stderr, "### jAPCMȊOWAVt@C`͖ΉłB\n");
		abort();
	}

	/* Xg[obt@쐬܂B
	 * ϊPʂ IN_BUFFER_SIZEȏ  nBlockAlign̐{ ̃TCYƂ܂B
	 */
	wav_unit = (IN_BUFFER_SIZE + (wav_fmt->nBlockAlign - 1)) / wav_fmt->nBlockAlign * wav_fmt->nBlockAlign;
	retval = acmStreamSize(acm, wav_unit, &pcm_unit, ACM_STREAMSIZEF_SOURCE);
	if(retval != 0) {
		fprintf(stderr, "### acmStreamSize()s܂B\n");
		abort();
	}
	memset(&stream, 0, sizeof stream);
	stream.cbStruct = sizeof stream;
	stream.pbSrc = (unsigned char*)malloc(wav_unit);
	stream.cbSrcLength = wav_unit;
	stream.pbDst = (unsigned char*)malloc(pcm_unit);
	stream.cbDstLength = pcm_unit;
	if(stream.pbSrc == NULL || stream.pbDst == NULL) {
		fprintf(stderr, "### słB\n");
		abort();
	}
	retval = acmStreamPrepareHeader(acm, &stream, 0);
	if(retval != 0) {
		fprintf(stderr, "### acmStreamPrepareHeader()s܂B\n");
		abort();
	}

	/* ϊ[vB
	 * * data`N̎coCg̓vOƐȂ΂Ȃ悤łB
	 *   mmioRead()ɔCƁAdata`Ň̃pfBOH܂œǂł܂݂B
	 */
	remain = ck_data.cksize; /* cf[^TCY */
	while(remain > 0) {
		/* ̓f[^ǂݍ݂܂B */
		stream.cbSrcLength = remain > wav_unit ? wav_unit : remain; /* ̓ǂݍ݃f[^TCY */
		retval = mmioRead(wav_mmio, (char*)stream.pbSrc, stream.cbSrcLength);
		if(retval != (int)stream.cbSrcLength) {
			fprintf(stderr, "### ̓t@CsłB\n");
			abort();
		}
		remain -= stream.cbSrcLength; /* cf[^TCY炷 */

		/* ϊ܂B */
		retval = acmStreamConvert(acm, &stream, 0);
		if(retval != 0) {
			fprintf(stderr, "### acmStreamConvert()s܂B\n");
			abort();
		}

		/* ϊPʂnBlockAlign̐{Ȃ̂ŁAꕔῗ肦Ȃ͂B */
		if(stream.cbSrcLengthUsed != stream.cbSrcLength) {
			fprintf(stderr, "### cbSrcLengthUsed != cbSrcLength\n");
			abort();
		}

		/* PCMf[^݂܂B */
		retval = fwrite((char*)stream.pbDst, 1, stream.cbDstLengthUsed, pcm_file);
		if(retval != (int)stream.cbDstLengthUsed) {
			fprintf(stderr, "### PCMt@C֏߂܂B\n");
			abort();
		}
	}

	/* Xg[obt@폜܂B
	 * * acmStreamUnprepareHeader()ĂԑOɁA
	 *   cbSrcLengthacmStreamPrepareHeader()Ɠlɖ߂ĂȂƁA
	 *   acmStreamUnprepareHeader()G[Ԃ悤łB
	 * * Ō̕ϊł́AcbSrcLengthwav_unitȒlɂȂĂ̂ŁA
	 *   ̂܂acmStreamUnprepareHeader()Ăł܂ƁAs܂B
	 */
	stream.cbSrcLength = wav_unit; /* Kv!! */
	retval = acmStreamUnprepareHeader(acm, &stream, 0);
	if(retval != 0) {
		fprintf(stderr, "### acmStreamUnprepareHeader()s܂B\n");
		abort();
	}
	free(stream.pbSrc);
	free(stream.pbDst);

	/* ACMXg[܂B */
	retval = acmStreamClose(acm, 0);
	if(retval != 0) {
		fprintf(stderr, "### acmStreamClose()s܂B\n");
		abort();
	}

	/* data`N𔲂܂B */
	retval = mmioAscend(wav_mmio, &ck_data, 0);
	if(retval != 0) {
		fprintf(stderr, "### WAVt@CsłB\n");
		abort();
	}

	/* RIFF`N𔲂܂B */
	retval = mmioAscend(wav_mmio, &ck_riff, 0);
	if(retval != 0) {
		fprintf(stderr, "### WAVt@CsłB\n");
		abort();
	}

	/* PCMt@C܂B */
	retval = fclose(pcm_file);
	if(retval != 0) {
		fprintf(stderr, "### PCMt@C܂B\n");
		abort();
	}

	/* WAVt@C܂B */
	retval = mmioClose(wav_mmio, 0);
	if(retval != 0) {
		fprintf(stderr, "### WAVt@C܂B\n");
		abort();
	}

	/* WAVwb_J܂B */
	free(wav_fmt);
}

void
pcm2gsm(const char* pcm_path, const char* gsm_path)
{
	int retval;
	FILE *pcm_file, *gsm_file;
	gsm g;
	gsm_frame f;
	gsm_signal s[160];

	/* PCMt@CJ܂B */
	pcm_file = fopen(pcm_path, "rb");
	if(pcm_file == NULL) {
		fprintf(stderr, "### PCMt@CJ܂B\n");
		abort();
	}

	/* GSMt@C쐬܂B */
	gsm_file = fopen(gsm_path, "wb");
	if(gsm_file == NULL) {
		fprintf(stderr, "### GSMt@C쐬ł܂B\n");
		abort();
	}

	/* GSMXg[쐬܂B */
	g = gsm_create();
	if(g == NULL) {
		fprintf(stderr, "### gsm_create()s܂B\n");
		abort();
	}

	/* ϊ[vB */
	for(;;) {
		/* PCMf[^ǂݍ݂܂B */
		retval = fread(s, sizeof(gsm_signal), 160, pcm_file);
		if(retval == 0) break; /* f[^Ȃ */
		memset(&s[retval], 0, sizeof(gsm_signal) * (160 - retval));

		/* ϊ܂B */
		gsm_encode(g, s, f);

		/* GSMf[^݂܂B */
		retval = fwrite(f, 1, sizeof f , gsm_file);
		if(retval != sizeof f) {
			fprintf(stderr, "### GSMt@C֏߂܂B\n");
			abort();
		}
	}

	/* GSMXg[폜܂B */
	gsm_destroy(g);

	/* GSMt@C܂B */
	retval = fclose(gsm_file);
	if(retval != 0) {
		fprintf(stderr, "### GSMt@C܂B\n");
		abort();
	}

	/* PCMt@C܂B */
	retval = fclose(pcm_file);
	if(retval != 0) {
		fprintf(stderr, "### PCMt@C܂B\n");
		abort();
	}
}
